#!/usr/bin/perl
# 
# ezjempg.$cgi - EZ JustEarth Messenger Generator - by Manny Juan <manny@jps.net> 4/3/99
# http://www.mannyjuan.com/maillist/
#
# this program was adapted from the JustEarth Messengers script by script solutions
#
# This will give your visitors the opportunity to set up a JustEarth Messenger
# at your site. 
#
#####################################################################################
$cgi="pl";
$SIG{__DIE__} = \&Error_Msg;

sub Error_Msg {
    $msg = "@_";
    print "\ncontent-type: text/html\n\n";
    print "The following error occurred : $msg\n";
    exit;
}

# Get the input
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

    # split the input
    @pairs = split(/&/, $input);

    # split the name/value pairs
    foreach $pair (@pairs) {

    ($name, $value) = split(/=/, $pair);

    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#    if (!(($name eq "whdr") or ($name eq "wftr"))) {
#        $value =~ s/<([^>]|\n)*>//g;
#        }
    if ($name eq 'usrlist') {
       push (@{$FORM{$name}}, $value);
       push (@{$FORM{$name}}, 1);
       }
    else {
        $FORM{$name} = $value;
        }
    }

######################################################################################
# set variables HERE
# $baseurl="http://10.26.36.193/jem";
# $basedir="../webpages/jem";
# $cgiurl="/cgi-bin";
$baseurl="http://www.mannyjuan.com/jem";
$basedir="/iiw/htdocs/www.mannyjuan.com/jem";
$cgiurl="/cgi-bin";

$usrpass="userpass.dat";

# This is a URL and dir for the images sub directory in the userpages directory.
# Create the images directory in the userpages directory.
$imageurl = $baseurl;

# This is the index list of all generated JustEarth Messengers
$indexpage = "$basedir/index.html";

# This is the location of the data.txt file. This holds each user's
# login name and e-mail address for confirmation
$users = "$basedir/data.txt";

# config file
$cfgname = "myjem.cfg";

# This is the location of the data.txt file. This holds each user's
# login name and e-mail address for confirmation
$lastmsg = "data.txt";

#Site title

$title="EZ JustEarth Messenger Mall";

# self explanatory variables for your site logo
$logo = "$imageurl/mjmall.jpg";
$logoalt = "EZ JustEarth Messenger Mall";

# Location of the sendmail program
$sendmail = '/usr/sbin/sendmail';

# Your e-mail address here
$myemail = 'manny@jps.net';

# That's it.

# DO NOT CHANGE ANYTHING BELOW THIS LINE
######################################################################################

# Lets do some translating first
$usrname = $FORM{'usrname'};
$login = $FORM{'login'};
$email = $FORM{'email'};
$sitename = $FORM{'sitename'};
if(length($sitename)>30) {$sitename=substr($sitename,1,30);}
$updact = $FORM{'updact'};
$password=$FORM{'password'};
$pwdagain=$FORM{'pwdagain'};
$flock=$FORM{'flock'};
$colorset=$FORM{'colorset'};
$usrlist=$FORM{'usrlist'};

# If the user tries to add more than one word in
# the page name field, this will put an underscore
# in the spaces to make it one word
$login =~ s/ /_/g;
$login=~s/\W//g;
$password=~s/\W//g;
$pagename=$login;

if ($FORM{'action'} eq "New Page") {
    &newpage;
    }
if ($FORM{'action'} eq "Create Page") {
    &createpage;
    }
if ($FORM{'action'} eq "Edit Page") {
    &confirm("edit");
    }
if ($FORM{'action'} eq "checkuser") {
    &checkuser;
    }
if ($FORM{'action'} eq "recreate") {
    &recreate;
    }
if ($FORM{'action'} eq "Delete Page") {
    &confirm("delete");
    }
if ($FORM{'action'} eq "delete users") {
    &del_users;
    }
    exit;

sub newpage {

    ($usrname,$email,$sitename,$colorset)
    = split(/&&/, "");

    $colorset='FFFFFF~333333~006699~999900';
    $sitename = "";

    # print the edit-page form

    print "content-type: text/html\n\n";
    print "<html><head><title>Create Your Own JustEarth Messenger</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner;
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<p><font face=\"Arial, Geneva\"><h2>Create Your Own JustEarth Messenger</h2></font></p>\n";
    print "<p>Below is an empty form for you to fill in. The next four fields (<b>bold</b>) are required.\n";
    print "You can edit any part of your page later</p>\n";
    print "<p></p>\n";
    print "<form action=\"$cgiurl/ezjempg.$cgi\" method=POST>\n";
    print "<input type=hidden name=\"action\" value=\"Create Page\">\n";
    print "<b>Your name:</b>";
    print "<font size=\"-1\">(will appear in page as link to your email)</font><br>\n";
    print "<input type=text size=40 name=\"usrname\" value=\"$usrname\"><br><br>\n";
    print "<h3>(The next three fields will be used for editing - REMEMBER THEM!)</h3>\n";
    print "<b>Login Id:</b>\n";
    print "<font size=\"-1\">(one word, will become the name of JustEarth Messenger page)</font><br>\n";
    print "<input type=text size=40 name=\"login\" value=\"$login\"><br><br>\n";
    print "<b>Your e-mail:</b>\n";
    print "<font size=\"-1\">(used for editing, also for sending edit confirmation)</font><br>\n";
    print "<input type=text size=40 name=\"email\" value=\"$email\"><br><br>\n";
    print "<b>Password:</b>\n";
    print "<br><input type=password size=20 name=\"password\" value=\"$password\"><br><br>\n";
    print "<b>Enter Password again:</b>\n";
    print "<br><input type=password size=20 name=\"pwdagain\" value=\"$pwdagain\"><br><br>\n";

    &build_form_content;
    print "<P><input type=submit value=\"create page\">\n";
    print "</form>\n";
    print "</body></html>\n";
    }

sub createpage {

    # Now, lets do some error checking. Making sure they filled out each field
    &missing(missing_email) unless $email;
    &missing(missing_login) unless $login;
    &missing(missing_password) unless $password;
    &missing("re-entered password") unless $pwdagain;
    if ($password ne $pwdagain) {
        &missing("mismatching password fields");
        }    
    # if they try to name their page "index" This will stop them
    if (uc($pagename) eq "INDEX") {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
        print "<p>You cannot name your page <b>index</b>\n";
        print "Please go back and re-name your page</p>\n";
        print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
        exit;
        }
    # if they Don't give their page a sitename This will stop them
    if ($login eq "") {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<p>You MUST give your page a <b>JustEarth Messenger title</b>\n";
        print "Please go back and enter one for your page</p>\n";
        exit;
        }

    # if the user tries to name their page 
    # something that is already taken
    # this should stop them - it's a check for directory-present
    if (-d "$basedir/$pagename") {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<p>The JustEarth Messenger name: <b>$pagename</b>\n";
        print "is already taken.\n";
        print "Please go back and rename your page</p>\n";
        print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
        exit;
        }
    # create the new directory for pagename
    umask(000);  # UNIX file permission junk
    mkdir("$basedir/$pagename", 0777) unless (-d "$basedir/$pagename");     

    # create the new directory for pagename/data
    umask(000);  # UNIX file permission junk
    mkdir("$basedir/$pagename/data", 0777) unless (-d "$basedir/$pagename/data");     

    # create the user password file
    open (USRPASS,">$basedir/$pagename/$usrpass")||die "i can't create >$basedir/$pagename/$usrpass";
    close(USRPASS);

    # create the config file
    open (CFGFILE,">$basedir/$pagename/$cfgname")||die "i can't create >$basedir/$pagename/$cfgname";
    print CFGFILE  "$email&&$sitename&&$colorset&&$dum";
    close(CFGFILE);
    ($bkgdc, $textc, $linkc, $vlinkc) = split('~', $colorset);

    # create user index
    &create_user_index;


    # Write the login name and email address to a separate file for confirmation
    # when they want to edit their page
    open (FILE, ">>$users") || die "I can't open >>$users\n";
    if($flock){flock (FILE, 2) or die "can't lock data file\n";}
    $cryptpwd=crypt($password,$salt);
    print FILE "$login&&$email&&$cryptpwd\n";
    close(FILE);

    # Suck the index page, and write the new entry to it
    open(FILE, "$indexpage") || die "I can't open that file $indexpage\n";
    if($flock){flock (FILE, 1) or die "can't lock index file\n";}
    @lines = <FILE>;
    close(FILE);
    $sizelines = @lines;

    # Now, re-open the links file, and add the new link
    open(FILE, ">$indexpage") || die "I can't open that file >$indexpage\n";
    if($flock){flock (FILE, 2) or die "can't lock index file\n";}

    for ($a = 0; $a <= $sizelines; $a++) {

        $_ = $lines[$a];

        if (/<!--begin-->/) {

            print FILE "<!--begin-->\n";
            print FILE "<p><font face=\"Arial, Geneva\" size=4><a href=\"$cgiurl/jemtalk.pl?pagename=$pagename\">$sitename</a></font></p>\n";

        } else {
            print FILE $_;
            }
        }
    close(FILE);


    # Give the user a response
    print "content-type: text/html\n\n";
    print "<html><head><title>thanks</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner;
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<BR><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";

    print "Your JustEarth Messenger has been created, and you will receive an e-mail confirming this!\n";
    print "You can visit your JustEarth Messenger by clicking ";
    print "<a href=\"$cgiurl/jemtalk.pl?pagename=$pagename\">here</a>\n";
    print "  The index page has been updated with this link.\n";
    print "Thanks for your participation!\n";
    print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
    print "</body></html>\n";


    # Send the user an e-mail confirming their page
    open (MAIL, "| $sendmail -t") || die "I can't open sendmail\n";
    print MAIL "To: $usrname <$email>\n";
    print MAIL "From: $myemail\n";
    print MAIL "Subject: Your new URL on the $title\n";
    print MAIL "Your page can be viewed at the URL below:\n";
    print MAIL "\n";
    print MAIL "$cgiurl/jemtalk.pl?pagename=$pagename\n";
    print MAIL "\nThank you for using the $title\n";
    print MAIL "\n\nThe Mall Manager - $myemail\n";
    close (MAIL);

    # Notify us when someone creates a page
    open (MAIL, "| $sendmail -t") || die "I can't open sendmail\n";
    print MAIL "To: $myemail\n";
    print MAIL "From: $usrname <$email>\n";
    print MAIL "Subject: $title New Page Report\n";
    print MAIL "$usrname created a new page:\n";
    print MAIL "$cgiurl/jemtalk.pl?pagename=$pagename\n";
    close(MAIL);

    }

sub create_user_index {
    open (IDXFILE,">$basedir/$pagename/index.html")||die "i can't open >$basedir/$pagename/index.html";
    print IDXFILE <<EOHTML;
<html><head><title>
ezjempg Version 1.0!
</title></head>
<body><center><h1>$sitename</h1><h3>JustEarth Messenger</h3></center><hr>
<a href="$cgiurl/jemtalk.pl?pagename=$pagename">start here</a>
</body></html>
EOHTML
    close(IDXFILE);
    }

sub recreate {
    # Suck the index page, and update site name (in case it changed)
    open(FILE, "$indexpage") || die "I can't open that file $indexpage\n";
    if($flock){flock (FILE, 1) or die "can't lock index file\n";}
        @lines = <FILE>;
        close(FILE);
        $sizelines = @lines;

    # Now, re-open the links file, and replace the index entry
    open(FILE, ">$indexpage") || die "I can't open that file >$indexpage\n";
    if($flock){flock (FILE, 2) or die "can't lock index file to delete entry\n";}

            for ($a = 0; $a <= $sizelines; $a++) {

            $_ = $lines[$a];

        if (/\=$pagename\b/) {
            print FILE "<p><font face=\"Arial, Geneva\" size=4><a href=\"$cgiurl/jemtalk.pl?pagename=$pagename\">$sitename</a></font></p>\n";
          } 
        else {
          print FILE $_;
           }
        }
    close(FILE);

    # recreate the config file
    open (CFGFILE,">$basedir/$pagename/$cfgname")||die "i can't open >$basedir/$pagename/$cfgname";
    print CFGFILE 
"$email&&$sitename&&$colorset&&$dum";
    close(CFGFILE);
    ($bkgdc, $textc, $linkc, $vlinkc) = split('~', $colorset);

    # recreate the user index page
    &create_user_index;

    &ntfy_usr_edt;

    # Give the user a response
    print "content-type: text/html\n\n";
    print "<html><head><title>thanks</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner;
    print "<CENTER><IMG SRC=\"$logo\" alt=\"$logoalt\" border=0></CENTER>\n";
    print "<P><BR><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
    print "Your JustEarth Messenger has been revised, and you will receive an e-mail confirming this!\n";
    print "You may visit your JustEarth Messenger by clicking ";
    print "<a href=\"$cgiurl/jemtalk.pl?pagename=$pagename\">here</a>\n";
    print "Thanks for your participation!\n";
    print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
    print "</body></html>\n";
    }

sub ntfy_usr_edt {
    # Send the user a notice that their page has been re-done
    open (MAIL, "| $sendmail -t") || die "I can't open sendmail\n";
    print MAIL "To: $usrname <$email>\n";
    print MAIL "From: $myemail\n";
    print MAIL "Subject: Your Changes on the $title\n";
    print MAIL "Your revised page can be viewed at the URL below:\n";
    print MAIL "\n";
    print MAIL "$cgiurl/jemtalk.pl?pagename=$pagename\n";
    print MAIL "\nOnce again thank you for using the $title\n";
    print MAIL "\n\nThe Mall Manager\n";
    close (MAIL);
    }

sub chk_bad_maxdepn {
    if ($maxdepn !~ /^(\d){1,3}$/) {
        &input_error("invalid or unreasonable value for max items in a category (enter 1 to 99)");
        exit;
        }
    }
sub chk_bad_maxdays {
    if ($maxdays !~ /^(\d){1,3}$/) {
        &input_error("invalid or unreasonable value for max retention days (enter 1 to 99)");
        exit;
        }
    }
sub input_error {
    local ($errmsg) = @_;
    print "content-type: text/html\n\n";
    print "<html><head><title>Error</title></head>\n";
    print "<body>";
    &put_banner;
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<h1>Input Error!</h1><h3>$errmsg.</h3>\n";
    print "<p>Please go back and correct</p>\n";
    }

# Standard error message for any missing required fields
sub missing {
    local ($missing) = @_;
    print "content-type: text/html\n\n";

    print "<HTML><head><TITLE>You missed something</TITLE></head>\n";
    print "<body>\n";
    &put_banner;    
    print "You forgot to fill in one of the fields. Please go back and make\n";
    print "sure that all required fields are filled in! <b>$missing</b>\n";
    print "</body></HTML>\n";
    exit;
    }

sub confirm {
    local ($updact) = @_;

    print "content-type: text/html\n\n";
    print "<html><head><title>$updact Confirmation</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\" >\n";
    &put_banner; 
    print "<CENTER><IMG SRC=\"$logo\" alt=\"$logoalt\"  border=0></CENTER>\n";
    print "<P><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
    print "<p><h3>Please Enter your login name, e-mail and your password</h3>\n";
    print "<form action=\"$cgiurl/ezjempg.$cgi\" method=POST>\n";
    print "<P><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
    print "Login name:<br>\n";
    print "<input size=40 type=text name=\"login\"><br>\n";
    print "E-mail:<br>\n";
    print "<input size=40 type=text name=\"email\"><br>\n";
    print "Enter password:<br>\n";
    print "<input type=password size=40 name=\"password\"><br><br>\n";
    print "<input type=submit value=submit>\n";
    print "<input type=hidden name=\"action\" value=\"checkuser\">\n";
    print "<input type=hidden name=\"updact\" value=\"$updact\">\n";
    print "</FONT>\n";
    print "</form></body></html>\n";
    }

sub checkuser {
    open(FILE, "$users") || die "I can't open $users\n";  
    if($flock){flock (FILE, 1) or die "can't lock users file\n";}
    while(<FILE>) {
    chop;       
    @all = split(/\n/);

    foreach $line (@all) {
    ($loginname, $loginemail, $loginpwd) = split(/&&/, $line);
    if($loginname eq "$login" && $loginemail eq "$email" 
    && $loginpwd eq crypt($password,$salt)) {
        $match = 1;
        if($updact eq "edit") {
          &edit($loginname);
          }
        else {
          &delpage($loginname);
          }
        }
      }
    }

    close(FILE);

    if (! $match) {
        &error;
        }

    # del entry from data
    if($updact eq "delete") {

        # Suck the users file, and update it
        open(FILE, "$users") || die "I can't open that file $users\n";
        if($flock){flock (FILE, 1) or die "can't lock data file\n";}
            @lines = <FILE>;
            close(FILE);
            $sizelines = @lines;

        # Now, re-open the links file, and comment out the page to delete
        open(FILE, ">$users") || die "I can't open that file >$users\n";
        if($flock){flock (FILE,2) or die "can't lock users file for append\n";}
        chop;
            for ($a = 0; $a <= $sizelines; $a++) {
            $_ = $lines[$a];
            $w = $_;
            $w =~ s/\cM//g;
            $w =~ s/\n//g;
            ($loginname, $loginemail, $loginpwd) = split(/&&/, $line);
            if($loginname eq "$login" && $loginemail eq "$email" 
            && $loginpwd eq crypt($password,$salt)) {
              # do nothing  (ie. don't write)
              } 
            else {
              if($w eq "") {
                # do nothing (skip)
                }
              else {
                print FILE "$w\n";
                }
              }
            }
        close(FILE);
        print "content-type: text/html\n\n";
        print "<html><head><title>$updact Confirmation</title></head>\n";
        print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\" >\n";
        &put_banner; 
        print "<CENTER><IMG SRC=\"$logo\" alt=\"$logoalt\" border=0></CENTER>\n";
        print "<P><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
        print "<p>your page has been deleted";
        print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
        print "</form></body></html>\n";
      }
    }

sub edit {
    ($pagename) = @_;

    # get the config file
    open(CFGFILE, "$basedir/$pagename/$cfgname") || die "I can't open $basedir/$pagename/$cfgname\n";
    if($flock){flock (CFGFILE, 1) or die "can't lock $basedir/$pagename/$cfgname for edit\n";}
    $txrec=<CFGFILE>;
    ($email,$sitename, $colorset,$dum)=split('&&',$txrec);
    ($bkgdc, $textc, $linkc, $vlinkc) = split('~', $colorset);

    close(CFGFILE);

    &build_edit_form("$sitename&&$pagename");
    }

sub delpage {
    local ($pagename) = @_;
    &deltree(0,"$basedir/$pagename");

    # Suck the index page, and store entries in array
    open(FILE, "$indexpage") || die "I can't open that file $indexpage\n";
    if($flock){flock (FILE, 1) or die "can't lock index file\n";}
        @lines = <FILE>;
        close(FILE);
        $sizelines = @lines;

    # Now, recreate the page but do not write the deleted page
    open(FILE, ">$indexpage") || die "I can't open that file >$indexpage\n";
    if($flock){flock (FILE, 2) or die "can't lock index file to delete entry\n";}
        for ($a = 0; $a <= $sizelines; $a++) {
        $_ = $lines[$a];
        if (/\=$pagename\b/) {
          # do nothing  (ie. don't write)
          } 
        else {
          print FILE $_;
           }
        }
    close(FILE);

    # Suck the users page, and store entries in array
    open(FILE, "$users") || die "I can't open that file $users\n";
    if($flock){flock (FILE, 1) or die "can't lock users file\n";}
        @lines = <FILE>;
        close(FILE);
        $sizelines = @lines;

    # Now, recreate the page but do not write the deleted page
    open(FILE, ">$users") || die "I can't open that file >$users\n";
    if($flock){flock (FILE, 2) or die "can't lock users file to delete entry\n";}
        for ($a = 0; $a <= $sizelines; $a++) {
        $_ = $lines[$a];
        if (/\=$pagename\b/) {
          # do nothing  (ie. don't write)
          } 
        else {
          print FILE $_;
           }
        }
    close(FILE);
    }

sub deltree {
    local ($lvl, $dir) = @_;
    local @tnlist;
    opendir (TN, "$dir");
    rewinddir (TN);
    @tnlist =  grep(!/^\.\.?$/, readdir (TN));
    closedir (TN);
    foreach $tn (@tnlist) {
        if (-d "$dir/$tn") {
            $lvl++;
            &deltree($lvl,"$dir/$tn" );
            $lvl--;
            }
        else {
            $cnt=unlink("$dir/$tn");
#            print "<br>deleting $dir/$tn";
            }
        }
    rmdir ("$dir");
#    print "<br>removing $dir";
    }

sub build_edit_form {
    local ($line) = @_;
    ($sitename,$pagename)=split(/&&/,$line);

    # print the edit-page form

    print "content-type: text/html\n\n";
    print "<html><head><title>Edit Your Page</title></head>\n"; 
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";

    &put_banner; 
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<table width=75% cellspacing=2 cellpadding=2 border=0>\n";
    print "<tr><td width=100% align=left valign=top>\n";
    print "<p><font face=\"Arial, Geneva\"><h2>Edit Your Page</h2></font></p>\n";
    print "<p>Below is a form with the contents\n";
    print "of the JustEarth Messenger you created. You can edit any part of your board</p>\n";
    print "<p></p>\n";
    print "<form action=\"$cgiurl/ezjempg.$cgi\" method=POST>\n";
    print "<input type=hidden name=\"action\" value=\"recreate\">\n";
    print "Your e-mail: <b>$email</b><br><br>\n";
    print "</td></tr></table>\n";
    print "Name of JustEarth Messenger: <b>$pagename</b><br><br>\n";
    print "<input type=hidden name=\"login\" value=\"$login\">\n";
    print "<input type=hidden name=\"email\" value=\"$email\">\n";

    &build_form_content;
    print "<P><input type=submit name=\"selection\" value=\"update page\">\n";
    print "</form>\n";
    print "<hr><p><font face=\"Arial, Geneva\"><h2>Delete Users</h2></font></p>\n";
    print "<form action=\"$cgiurl/ezjempg.$cgi\" method=POST>\n";
    open (USRPASS,"$basedir/$pagename/$usrpass")||die "i can't open $basedir/$pagename/$usrpass for reading";
    $usrlist= <USRPASS>;
    close(USRPASS);
    @lines = split(/&/,$usrlist);
    $n=1;
    foreach $line (@lines) {
        ($tmp,$tmpa) = split(/\|/,$line);
        print "<!--u=$n-->\n<br><INPUT TYPE=\"CHECKBOX\" NAME=\"usrlist\" VALUE=\"$tmp\">&nbsp;$tmp\n";
        $n++;
        }
    print "\n<input type=hidden name=\"login\" value=\"$pagename\">";
    print "\n<input type=hidden name=\"action\" value=\"delete users\">";
    print "\n<P><input type=submit name=\"selection\" value=\"delete users\">\n";
    print "</form>\n";
    print "</body></html>\n";
    }

sub build_form_content {
    print "<br><b>JustEarth Messenger Title:</b>\n";
    print "<font size=\"-1\">(title of JustEarth Messenger - will be listed in index)</font><br>\n";
    print "<input type=text size=40 name=\"sitename\" value=\"$sitename\"><br>\n";
    print "\n<br><br><b>Select Color Scheme:</b>";
    print "<SELECT NAME=\"colorset\">";
    &put_optvar($colorset,'01','FFFFFF~333333~006699~999900');
    &put_optvar($colorset,'02','CCCCCC~000000~0000CC~660066');
    &put_optvar($colorset,'03','FFFF00~FF6600~FF0033~336633');
    &put_optvar($colorset,'04','CCCC66~330000~CC0000~003300');
    &put_optvar($colorset,'05','FFFF99~330000~CC0000~333333');
    &put_optvar($colorset,'06','99CCCC~000066~0000CC~003366');
    &put_optvar($colorset,'07','CC99FF~000000~FF0033~660066');
    &put_optvar($colorset,'08','CCFF99~666600~006699~003300');
    &put_optvar($colorset,'09','FFCC00~330000~CC0000~660066');
    &put_optvar($colorset,'10','00FF33~0000CC~FF0099~660066');
    &put_optvar($colorset,'11','006699~CCFFCC~FFFF00~00FFFF');
    &put_optvar($colorset,'12','330000~FF6666~FFCC00~CCFF99');
    &put_optvar($colorset,'13','003300~CCCC66~FFFFFF~FFFF00');
    &put_optvar($colorset,'14','333333~CCCCCC~FF6666~CCCC66');
    &put_optvar($colorset,'15','666600~FFFFFF~FFFF00~99CCFF');
    &put_optvar($colorset,'16','000000~99CCFF~FFFF00~CCCC66');
    &put_optvar($colorset,'17','333333~FFFFFF~99CCFF~CC99FF');
    &put_optvar($colorset,'18','CC0000~FFFFFF~FFFF00~00FFFF');
    print "\n</SELECT>";
    print "<br><img src=\"$baseurl/ezpalette.gif\"><br>";
    print "<p>";
    }

sub prt_ckb {
    local ($var, $varname, $ckbdesc) = @_;
    print "\n<INPUT TYPE=\"CHECKBOX\" NAME=\"$varname\" VALUE=\"1\"";
    if ($var eq "1") {print " CHECKED";} 
    print ">&nbsp;&nbsp;$ckbdesc<br>";
    }

sub prt_ckb_tb {
    local ($var, $varname, $ckbdesc) = @_;
    print "\n<tr><td><INPUT TYPE=\"CHECKBOX\" NAME=\"$varname\" VALUE=\"1\"";
    if ($var eq "1") {print " CHECKED";} 
    print "></td>";
    print "<td>$ckbdesc</td></tr>";
    }

sub put_optvar  {
    local ($optvar, $id, $value)=@_;
    print "\n<OPTION VALUE=\"$value\"";
    if ($optvar eq $value) {print " SELECTED";}
    print ">$id";
    }

sub error {
    local ($updact) = @_;
    print "content-type: text/html\n\n";
    print "<html><head><title>Permission Denied</title></head>\n";
    print "<body>\n";
    &put_banner; 
    print "<p><h1>Permission Denied</h1></p>\n";
    print "You do not have permission to $updact\n";
    print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
    print "</body></html>\n";
    exit;
    }
sub put_banner {
    # do nothing
    }
sub del_users {
    %dellist=@{$usrlist};
#    print "manny=$dellist{'manny'} jerry=$dellist{'jerry'} lisa=$dellist{'lisa'}";
    open (USRPASS,"$basedir/$pagename/$usrpass")||die "i can't open $basedir/$pagename/$usrpass for reading";
    $usrlist= <USRPASS>;
    close(USRPASS);
    @lines = split(/&/,$usrlist);

    open (USRPASS,">$basedir/$pagename/$usrpass")||die "i can't open >$basedir/$pagename/$usrpass";
    foreach $line (@lines) {
        ($tmp,$tmpa) = split(/\|/,$line);
        if($dellist{"$tmp"}==1) {
            #do nothing
            }
        else {
            print USRPASS "$tmp|$tmpa&";
            }
        }
    close(USRPASS);

    print "content-type: text/html\n\n";
    print "<html><head><title>User Deletion</title></head>\n";
    print "<body>";
    print "<h3>User Deletion Confirmation</h3>";
    foreach $line (@lines) {
        ($tmp,$tmpa) = split(/\|/,$line);
        if($dellist{"$tmp"}==1) {
            $cnt=unlink("$basedir/$pagename/data/$tmp");
            print "<br>user <b>$tmp</b> has been deleted";
            }
        }
    print "</body></html>";
    }
